ur_rna.Utilities.geom

## Class Ellipses

- java.lang.Object
- - ur_rna.Utilities.geom.Ellipses

-     public class Ellipses
      extends java.lang.Object

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `Ellipses.Circle`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static double` | `toScreenDegrees`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Ellipses()`

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static java.awt.geom.Arc2D.Double` | `arc(java.awt.geom.Point2D center, double radius, double startAngle, double endAngle, boolean reversed, int arcType)` The normal Arc2D constructor expects the angles in degrees.
    `static java.awt.geom.Arc2D.Double` | `arc(java.awt.geom.Point2D center, double radius, double startAngle, double arcAngle, int arcType)`
    `static double` | `calcArcExtent(double startAngle, double endAngle, boolean reversed)`
    `static java.awt.geom.Ellipse2D.Double` | `fromCenter(double x, double y, double radius)`
    `static java.awt.geom.Ellipse2D.Double` | `fromCenter(double x, double y, double w, double h)`
    `static java.awt.geom.Ellipse2D.Double` | `fromCenter(java.awt.geom.Point2D p, double radius)`
    `static java.awt.geom.Ellipse2D.Double` | `fromCenter(java.awt.geom.Point2D p, double w, double h)`
    `static java.awt.geom.Ellipse2D.Double` | `fromCenter(Vec2D p, double radius)`
    `static java.awt.geom.Ellipse2D.Double` | `fromCenter(Vec2D p, double w, double h)`
    `static java.awt.geom.Ellipse2D.Double` | `fromRect(java.awt.geom.Rectangle2D rc)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### toScreenDegrees

          public static final double toScreenDegrees

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### Ellipses

          public Ellipses()

  - ### Method Detail

    - #### arc

          public static java.awt.geom.Arc2D.Double arc(java.awt.geom.Point2D center,
                                                       double radius,
                                                       double startAngle,
                                                       double endAngle,
                                                       boolean reversed,
                                                       int arcType)

      The normal Arc2D constructor expects the angles in degrees. Additionally it
      Parameters:
        `center` - the center of the arc's circle
        `radius` - the radius of the arc's circle
        `startAngle` - the starting angle in radians. This will be multiplied by `toScreenDegrees` to account for the upside-down screen coordinates and convert from radians to degrees.
        `endAngle` - the end angle in radians. This will be multiplied by `toScreenDegrees` to account for the upside-down screen coordinates and convert from radians to degrees.
        `reversed` - The direction in which the arc should be drawn clockwise(reversed=true) or counter-clockwise(reversed=false).
        `arcType` - The type of arc to draw: `Arc2D.CHORD`, `Arc2D.PIE`, or `Arc2D.OPEN`

    - #### arc

          public static java.awt.geom.Arc2D.Double arc(java.awt.geom.Point2D center,
                                                       double radius,
                                                       double startAngle,
                                                       double arcAngle,
                                                       int arcType)

    - #### calcArcExtent

          public static double calcArcExtent(double startAngle,
                                             double endAngle,
                                             boolean reversed)

    - #### fromCenter

          public static java.awt.geom.Ellipse2D.Double fromCenter(double x,
                                                                  double y,
                                                                  double radius)

    - #### fromCenter

          public static java.awt.geom.Ellipse2D.Double fromCenter(double x,
                                                                  double y,
                                                                  double w,
                                                                  double h)

    - #### fromCenter

          public static java.awt.geom.Ellipse2D.Double fromCenter(java.awt.geom.Point2D p,
                                                                  double radius)

    - #### fromCenter

          public static java.awt.geom.Ellipse2D.Double fromCenter(java.awt.geom.Point2D p,
                                                                  double w,
                                                                  double h)

    - #### fromCenter

          public static java.awt.geom.Ellipse2D.Double fromCenter(Vec2D p,
                                                                  double radius)

    - #### fromCenter

          public static java.awt.geom.Ellipse2D.Double fromCenter(Vec2D p,
                                                                  double w,
                                                                  double h)

    - #### fromRect

          public static java.awt.geom.Ellipse2D.Double fromRect(java.awt.geom.Rectangle2D rc)